org.jboss.netty.handler.codec.frame

## Class FixedLengthFrameDecoder

- java.lang.Object
- - org.jboss.netty.channel.SimpleChannelUpstreamHandler
  - - org.jboss.netty.handler.codec.frame.FrameDecoder
    - - org.jboss.netty.handler.codec.frame.FixedLengthFrameDecoder

- All Implemented Interfaces:
    ChannelHandler, ChannelUpstreamHandler, LifeCycleAwareChannelHandler

      public class FixedLengthFrameDecoder
      extends FrameDecoder

  A decoder that splits the received `ChannelBuffer`s by the fixed number of bytes. For example, if you received the following four fragmented packets:

       +---+----+------+----+
       | A | BC | DEFG | HI |
       +---+----+------+----+

  A `FixedLengthFrameDecoder``(3)` will decode them into the following three packets with the fixed length:

       +-----+-----+-----+
       | ABC | DEF | GHI |
       +-----+-----+-----+

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.jboss.netty.channel.ChannelHandler

      `ChannelHandler.Sharable`

  - ### Field Summary

    - ### Fields inherited from class org.jboss.netty.handler.codec.frame.FrameDecoder

      `cumulation, DEFAULT_MAX_COMPOSITEBUFFER_COMPONENTS`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FixedLengthFrameDecoder(int frameLength)` Calls `FixedLengthFrameDecoder(int, boolean)` with `false`
    `FixedLengthFrameDecoder(int frameLength, boolean allocateFullBuffer)` Creates a new instance.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected Object` | `decode(ChannelHandlerContext ctx, Channel channel, ChannelBuffer buffer)` Decodes the received packets so far into a frame.
    `protected ChannelBuffer` | `newCumulationBuffer(ChannelHandlerContext ctx, int minimumCapacity)` Create a new `ChannelBuffer` which is used for the cumulation.

    - ### Methods inherited from class org.jboss.netty.handler.codec.frame.FrameDecoder

      `actualReadableBytes, afterAdd, afterRemove, appendToCumulation, beforeAdd, beforeRemove, channelClosed, channelDisconnected, cleanup, decodeLast, exceptionCaught, getMaxCumulationBufferCapacity, getMaxCumulationBufferComponents, internalBuffer, isUnfold, messageReceived, replace, setMaxCumulationBufferCapacity, setMaxCumulationBufferComponents, setUnfold, unfoldAndFireMessageReceived, updateCumulation`

    - ### Methods inherited from class org.jboss.netty.channel.SimpleChannelUpstreamHandler

      `channelBound, channelConnected, channelInterestChanged, channelOpen, channelUnbound, childChannelClosed, childChannelOpen, handleUpstream, writeComplete`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### FixedLengthFrameDecoder

          public FixedLengthFrameDecoder(int frameLength)

      Calls `FixedLengthFrameDecoder(int, boolean)` with `false`

    - #### FixedLengthFrameDecoder

          public FixedLengthFrameDecoder(int frameLength,
                                 boolean allocateFullBuffer)

      Creates a new instance.
      Parameters:
        `frameLength` - the length of the frame
        `allocateFullBuffer` - `true` if the cumulative `ChannelBuffer` should use the `frameLength` as its initial size

  - ### Method Detail

    - #### decode

          protected Object decode(ChannelHandlerContext ctx,
                      Channel channel,
                      ChannelBuffer buffer)
                           throws Exception

      Description copied from class: `FrameDecoder`
      Decodes the received packets so far into a frame.
      Specified by:
        `decode` in class `FrameDecoder`
      Parameters:
        `ctx` - the context of this handler
        `channel` - the current channel
        `buffer` - the cumulative buffer of received packets so far. Note that the buffer might be empty, which means you should not make an assumption that the buffer contains at least one byte in your decoder implementation.
      Returns:
        the decoded frame if a full frame was received and decoded. `null` if there's not enough data in the buffer to decode a frame.
      Throws:
        `Exception`

    - #### newCumulationBuffer

          protected ChannelBuffer newCumulationBuffer(ChannelHandlerContext ctx,
                                          int minimumCapacity)

      Description copied from class: `FrameDecoder`
      Create a new `ChannelBuffer` which is used for the cumulation. Sub-classes may override this.
      Overrides:
        `newCumulationBuffer` in class `FrameDecoder`
      Parameters:
        `ctx` - `ChannelHandlerContext` for this handler
      Returns:
        buffer the `ChannelBuffer` which is used for cumulation

Copyright © 2008-2012 The Netty Project. All Rights Reserved.